<?php
/**
 * Clase Base FN para BaseCrEventoTipoFN
 *
 * @package    
 * @subpackage BaseCrEventoTipoFN
 * @author     Willy
 * @version    SVN:: BaseCrEventoTipoFN.class.php,v 1.1 2023-02-22 18:07:17 william.taype Exp $
 */
class BaseCrEventoTipoFN extends CrEventoTipoBN
{
  private static $fieldNames = array (
    'IdEventoTipo'=>'IdEventoTipo', 'Decripcion'=>'Descripcion', 'Estado'=>'Estado', 'FechaCreacion'=>'FechaCreacion'  
  );

  public function select()
  {
    try
    {
      $tamPag = !property_exists($this, 'tamPag')?9999:$this->tamPag;
      $pagina = !property_exists($this, 'page')||$this->page==""?1:$this->page;
      $numeroRegistros = $this->selectNumRows();
      $limitInf = ($pagina-1)*$tamPag;

      $where = $this->buildConsult();
      $orden = $this->buildOrderByField();

      $con = Conexion::getConexion();
      $sql = "SELECT * FROM cr_evento_tipo WHERE 1 ".$where." ".$orden."  LIMIT ".$limitInf.",".$tamPag;
          $con = Conexion::getConexion();
        $result = mysql_db_query(Conexion::getNameDb(), $sql, $con);
      $num_rows = mysql_num_rows($result);
      $a_tmp = array();
      if($num_rows>0){
        while ($o_valor = mysql_fetch_object($result)) {
          $a_tmp[] = $this->insertObjectBN($o_valor);
        }
      }
      
      return count($a_tmp)>0?$a_tmp:null;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  public function selectNumRows()
  {
    try
    {
      $where = $this->buildConsult();

      $con = Conexion::getConexion();
      $sql = "SELECT * FROM cr_evento_tipo WHERE 1 ".$where;
          $con = Conexion::getConexion();
        $result = mysql_db_query(Conexion::getNameDb(), $sql, $con);
      $num_rows = mysql_num_rows($result);
      
      return $num_rows;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  public function buildConsult()
  {
    try
    {
      $where = "";

      if($this->getIdEventoTipo()){ $where .= " AND ideventotipo = '".$this->getIdEventoTipo()."'"; }
      if($this->getDescripcion()){ $where .= " AND descripcion = '".$this->getDecripcion()."'"; }
      if($this->getEstado()){ $where .= " AND estado = '".$this->getEstado()."'"; }
      if($this->getNombreClavePrimaria()){ $where .= " AND NombreClavePrimaria = '".$this->getNombreClavePrimaria()."'"; }
      if($this->getFechaCreacion()){ $where .= " AND fechacreacion = '".$this->getFechaCreacion()."'"; }
      return $where;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  public function buildOrderByField()
  {
    try
    {
      $order_by = "";

      if(property_exists($this,'sortCampos')){
      if($this->sortCampos != ""){
        $a_valCampos = explode(";", $this->sortCampos);
        $a_valtype   = explode(";", $this->sortType);
        $order_by = " ORDER BY ";
        $a_order = array();
        foreach ($a_valCampos as $key => $val){
          $sTmpOrder = "";
          if(array_key_exists($val, self::$fieldNames)){
            $sTmpOrder .= self::$fieldNames[$val];
            switch ($a_valtype[$key]){
              case 1: $sTmpOrder .= " ASC"; break;
              case 2: $sTmpOrder .= " DESC"; break;
            }
            $a_order[] = $sTmpOrder;
          }
        }
        $order_by .= implode(", ", $a_order);
      }
      }
      return $order_by;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  /* B�squeda del registro por la llave primaria */
  public function selectByPK()
  {
    try
    {
      $con = Conexion::getConexion();
      $sql = "SELECT * FROM cr_evento_tipo WHERE 1 AND IdEventoTipo='".$this->getIdEventoTipo()."'; ";
        $con = Conexion::getConexion();
        $result = mysql_db_query(Conexion::getNameDb(), $sql, $con);
      $o_Propel = $result ? mysql_fetch_object($result) : null;
      

      return $o_Propel?$this->insertObjectBN($o_Propel):null;

    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  /* Devuelve un objeto con m�todos de acceso */
  private function insertObjectBN($o_propel){
    $o_BaseCrEventoTipoFN = new BaseCrEventoTipoFN();
    $o_BaseCrEventoTipoFN->setIdEventoTipo($o_propel->IdEventoTipo);
    $o_BaseCrEventoTipoFN->setDescripcion($o_propel->Descripcion);
    $o_BaseCrEventoTipoFN->setEstado($o_propel->Estado);
    $o_BaseCrEventoTipoFN->setFechaCreacion($o_propel->FechaCreacion);
    $o_BaseCrEventoTipoFN->setNombreClavePrimaria($o_propel->NombreClavePrimaria);
    return $o_BaseCrEventoTipoFN;
  }
}